<?php

namespace FiloBlu\Referrals\Observer;

use FiloBlu\Referrals\Helper\Core;
use Magento\Framework\Event\Observer;

class CustomerCreatePost implements \Magento\Framework\Event\ObserverInterface
{

    /**
     * @var Core
     */
    protected $coreHelper;

    public function __construct(
        Core $coreHelper
    )
    {
        $this->coreHelper = $coreHelper;
    }

    public function execute(Observer $observer)
    {

        if (!$this->coreHelper->isEnabled()) {
            return false;
        }

        $customer = $observer->getEvent()->getCustomer();

        $invitation = $this->coreHelper->getInvitationByDbField('email', $customer->getEmail());

        if (!$invitation) {
            return false;
        }

        if (!$invitation->getInvitationId()) {
            return false;
        }

        $invitation->setReferralId($customer->getId())->save();
    }
}